struct text_print
{
  unsigned int x;
  unsigned char *text;
};

struct screen_region
{
  int x0;
  int y0;
  int x1;
  int y1;
};

struct hitbox
{
  int x0;
  int y0;
  int x1;
  int y1;
  unsigned int element;
};

struct window_element
{
  /* -- element types --
   0: static text or image
   1: button
   2: textbox
   3: list
   4: scrollbar
   5: icon
  */
  unsigned char type:5;
  // content-types: 0: text, 1: image
  unsigned ctype:1;
  unsigned active:1;
  unsigned monospace:1;
  unsigned int x, y;
  unsigned int width, height;
  unsigned char *text;
  unsigned char *bitmap;
  unsigned char **items;
  unsigned char __far * __far *fitems;
  unsigned int scroll_x, scroll_y;
  unsigned char color;
  unsigned int c;
  unsigned int p;
  int connect_element;
  int *connect_value;
  int selectc;
};

struct dropmenu
{
  unsigned char *title;
  unsigned char **items;
};

struct menu_bar
{
  unsigned char count;  
  struct dropmenu menubar;
  unsigned char **upleft;
  unsigned char upleft_count;
};

struct prog_window
{
  unsigned char *title;
  int x, y;
  int x2, y2, w2, h2;
  int width, height;
  unsigned resizable:1;
  unsigned minimizable:1;
  unsigned menubar:1;
  unsigned maximized:1;
  unsigned minimized:1;
  unsigned resized:1;
  unsigned hidden:1;
  struct window_element **window_grid;
  struct menu_bar menus;
  unsigned int element_count;
  unsigned int hitbox_count;
  struct hitbox *hitbox;
  unsigned char *icon;
  unsigned char type;
  unsigned int active_element;
  int (*function_pointer)(struct prog_window*, int, int*);
  void *function_status;
};

struct dialog_window
{
  /* -- dialog types --
   0: ok
   1: ok - cancel
   2: yes - no
   3: yes - no - cancel
   */
  unsigned char type;
  int x, y;
  unsigned int width, height;
  unsigned help_button:1;
  unsigned sound:3;
  unsigned char *message;
};

struct mouse_status
{
  int pointer_x;
  int pointer_y;
  unsigned left_pressed:1;
  unsigned right_pressed:1;
};

struct icon
{
  unsigned char *bitmap;
  unsigned char *text;
  int x, y;
  unsigned int value;
};

struct desktop_shortcut
{
  char shortcut_file[12];
  char path[81];
  unsigned char text[32];
  int x, y;
  unsigned char *icon;
  char *icon_path;
  unsigned char ask_args;
};

struct coords
{
  int x;
  int y;
};
