unsigned char upleft_move[] = "Move window";
unsigned char upleft_close[] = "Close window";
unsigned char upleft_maximize[] = "(Un)maximize";
unsigned char upleft_resize[] = "Resize";
unsigned char upleft_minimize[] = "Minimize";
unsigned char dialog_ok[] = "OK";
unsigned char dialog_cancel[] = "Cancel";
unsigned char dialog_yes[] = "Yes";
unsigned char dialog_no[] = "No";
unsigned char dialog_help[] = "Help [F1]";

/*

*/
void element_active(struct prog_window *window, int element)
{
  int n;

  n = window->active_element;
  window->active_element = -1;
  if(n >= 0)
    window_drawelement(window, n);  
  window->active_element = element;  
  if(element >= 0)
    window_drawelement(window, element);
}

void window_drawelement(struct prog_window *window, unsigned int element)
{
  unsigned int n;
  switch(window->window_grid[element]->type)
  {
    // only text
    case 0:
      gprint_text(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y,
        window->window_grid[element]->text, window->window_grid[element]->color, _FONT_HEIGHT, window->x+window->width, window->window_grid[element]->monospace);      
    return;
    // button
    case 1:
      draw_borders(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y,
        window->window_grid[element]->width, window->window_grid[element]->height, 0);
      gprint_text(window->x+10+window->window_grid[element]->x, window->y+1+_FONT_HEIGHT+2+window->window_grid[element]->y,
        window->window_grid[element]->text, window->window_grid[element]->color, _FONT_HEIGHT, window->x+10+window->window_grid[element]->x+window->window_grid[element]->width, window->window_grid[element]->monospace);            
    return;
    // icon
    case 5:
      draw_borders(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y, _WINDOW_ICONS_MARGIN-2, 39, 0);
      draw_icon(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y, window->window_grid[element]->bitmap, window->window_grid[element]->text, _WINDOW_BASICTEXTCOLOR);
    return;
    // textbox
    case 2:
      draw_borders(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y,
        window->window_grid[element]->width, window->window_grid[element]->height, 1);
      if(window->active_element != element)      
        draw_rectangle(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y,
          window->window_grid[element]->width, window->window_grid[element]->height, _TEXTBOX_BGCOLOR);
      else
        draw_rectangle(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y,
          window->window_grid[element]->width, window->window_grid[element]->height, _TEXTBOX_ABGCOLOR);
      if(window->window_grid[element]->text)
        gprint_text(window->x+window->window_grid[element]->x+2, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y+2,
          window->window_grid[element]->text, _TEXTBOX_TEXTCOLOR, _FONT_HEIGHT, window->x+window->window_grid[element]->x+window->window_grid[element]->width, window->window_grid[element]->monospace);            
    return;
    // list
    case 3:
      draw_borders(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y,
        window->window_grid[element]->width, window->window_grid[element]->height, 1);
      draw_rectangle(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y,
        window->window_grid[element]->width, window->window_grid[element]->height, _TEXTBOX_BGCOLOR);
      if(window->window_grid[element]->items)
      {
        for(n=window->window_grid[element]->scroll_y;
          n < window->window_grid[element]->c
          && n-window->window_grid[element]->scroll_y < (window->window_grid[element]->height / (_FONT_HEIGHT+2) );
            n++)
        {
          if(window->window_grid[element]->items[n])
          {
            if(window->window_grid[element]->selectc == n)
            {
              draw_rectangle(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y
               + ((n-window->window_grid[element]->scroll_y)*(_FONT_HEIGHT+2)), window->window_grid[element]->width,
               _FONT_HEIGHT+2, _ATEXT_BGCOLOR);
              if(strlen(window->window_grid[element]->items[n]) > window->window_grid[element]->scroll_x)
                gprint_text(window->x+window->window_grid[element]->x+2,
                  window->y+_FONT_HEIGHT+2+window->window_grid[element]->y+2
                   + ((n-window->window_grid[element]->scroll_y)*(_FONT_HEIGHT+2)),
                  &window->window_grid[element]->items[n][window->window_grid[element]->scroll_x], _TEXTBOX_ATEXTCOLOR, _FONT_HEIGHT, window->x+window->window_grid[element]->x+window->window_grid[element]->width, window->window_grid[element]->monospace);             
            }
            else   
              if(strlen(window->window_grid[element]->items[n]) > window->window_grid[element]->scroll_x)
                gprint_text(window->x+window->window_grid[element]->x+2,
                  window->y+_FONT_HEIGHT+2+window->window_grid[element]->y+2
                   + ((n-window->window_grid[element]->scroll_y)*(_FONT_HEIGHT+2)),
                  &window->window_grid[element]->items[n][window->window_grid[element]->scroll_x], _TEXTBOX_TEXTCOLOR, _FONT_HEIGHT, window->x+window->window_grid[element]->x+window->window_grid[element]->width, window->window_grid[element]->monospace);
          }
        }
      }
      if(window->window_grid[element]->fitems)
      {
        for(n=window->window_grid[element]->scroll_y;
          n < window->window_grid[element]->c
          && n-window->window_grid[element]->scroll_y < (window->window_grid[element]->height / (_FONT_HEIGHT+2) );
            n++)
        {
          if(window->window_grid[element]->fitems[n])
          {
            if(window->window_grid[element]->selectc == n)
            {
              draw_rectangle(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y
               + ((n-window->window_grid[element]->scroll_y)*(_FONT_HEIGHT+2)), window->window_grid[element]->width,
               _FONT_HEIGHT+2, _ATEXT_BGCOLOR);
              if(strlen(window->window_grid[element]->fitems[n]) > window->window_grid[element]->scroll_x)
                gprint_text(window->x+window->window_grid[element]->x+2,
                  window->y+_FONT_HEIGHT+2+window->window_grid[element]->y+2
                   + ((n-window->window_grid[element]->scroll_y)*(_FONT_HEIGHT+2)),
                  &window->window_grid[element]->fitems[n][window->window_grid[element]->scroll_x], _TEXTBOX_ATEXTCOLOR, _FONT_HEIGHT, window->x+window->window_grid[element]->x+window->window_grid[element]->width, window->window_grid[element]->monospace);             
            }
            else   
              if(strlen(window->window_grid[element]->fitems[n]) > window->window_grid[element]->scroll_x)
                gprint_text(window->x+window->window_grid[element]->x+2,
                  window->y+_FONT_HEIGHT+2+window->window_grid[element]->y+2
                   + ((n-window->window_grid[element]->scroll_y)*(_FONT_HEIGHT+2)),
                  &window->window_grid[element]->fitems[n][window->window_grid[element]->scroll_x], _TEXTBOX_TEXTCOLOR, _FONT_HEIGHT, window->x+window->window_grid[element]->x+window->window_grid[element]->width, window->window_grid[element]->monospace);
          }
        }
      }      
    return;
    // scrollbar
    case 4:
      // if vertical
      if(!window->window_grid[element]->ctype)
      {
        draw_borders(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y,
          12, 12, 0);
        draw_rectangle(window->x+window->window_grid[element]->x-1, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y+13,
          14, window->window_grid[element]->width, _SCROLLBAR_BGCOLOR);
        draw_borders(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y+14
        +window->window_grid[element]->width,
          12, 12, 0);
        // and draw the anchor
        if(window->window_grid[element]->c)
          draw_rectangle(window->x+window->window_grid[element]->x,
            window->y+_FONT_HEIGHT+2+window->window_grid[element]->y+13
            + (unsigned long)window->window_grid[element]->scroll_x * (window->window_grid[element]->width-12) / window->window_grid[element]->c, 12, 12,
            _WINDOW_BGCOLOR);
      }
      // if horizontal
      else
      {
        draw_rectangle(window->x+window->window_grid[element]->x+13, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y-1,
          window->window_grid[element]->width, 14, _SCROLLBAR_BGCOLOR);                    
        if(window->window_grid[element]->c)
          draw_rectangle(window->x+window->window_grid[element]->x+13
          + (unsigned long)window->window_grid[element]->scroll_x * (window->window_grid[element]->width-12) / window->window_grid[element]->c,
            window->y+_FONT_HEIGHT+2+window->window_grid[element]->y, 12, 12,
            _WINDOW_BGCOLOR);
        draw_borders(window->x+window->window_grid[element]->x, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y,
          12, 12, 0);
        draw_borders(window->x+window->window_grid[element]->x+14+window->window_grid[element]->width, window->y+_FONT_HEIGHT+2+window->window_grid[element]->y,
          12, 12, 0);
      }
    break;
  }
}

/*
Draws a window
If active != 0, the title bar is drawn blue, else it is drawn grey
If update == 0, draws whole window, if 1, draws only the contents,
if 2, draws only the titlebar, if 3, draws only the content and doesn't update mouse cursor's background
*/

void draw_window(struct prog_window *window, unsigned active, unsigned update)
{
  int scrrow = window->y+_FONT_HEIGHT+2;
//  int scrcol = window->x;
//  unsigned int n,m;
  unsigned int n;

  if(!update || update == 2)
  {
    // draw borders
    if(!update)
      if(!window->maximized)
        draw_borders(window->x, window->y, window->width, window->height+_FONT_HEIGHT+2, 0);
    // draw title bar
    if(active)    
      draw_rectangle(window->x, window->y, window->width, _FONT_HEIGHT+2, _TITLE_COLOR);
    else
      draw_rectangle(window->x, window->y, window->width, _FONT_HEIGHT+2, _TITLE_COLOR_IA);    
//    for(n=_FONT_HEIGHT+2;n;n--,scrrow++,scrcol=window->x)
//      for(m=window->width;m;m--,scrcol++)
      {
        // topright buttons
        if(window->resizable)
        {
          draw_borders(window->x+window->width-(_FONT_HEIGHT), window->y+2, _FONT_HEIGHT-2, _FONT_HEIGHT-2, 0);
          draw_rectangle_px(window->x+window->width-(_FONT_HEIGHT), window->y+2, _FONT_HEIGHT-2, _FONT_HEIGHT-2, _WINDOW_BGCOLOR);
          draw_line(window->x+window->width-(_FONT_HEIGHT)+1, window->y+3, window->x+window->width-4, window->y+3, 0x00);
        }
        if(window->minimizable)
        {
          draw_borders(window->x+window->width-2*(_FONT_HEIGHT+1)+1, window->y+2, _FONT_HEIGHT-2, _FONT_HEIGHT-2, 0);
          draw_rectangle_px(window->x+window->width-2*(_FONT_HEIGHT+1)+1, window->y+2, _FONT_HEIGHT-2, _FONT_HEIGHT-2, _WINDOW_BGCOLOR);
          draw_line(window->x+window->width-2*_FONT_HEIGHT, window->y+_FONT_HEIGHT-2, window->x+window->width-_FONT_HEIGHT-5, window->y+_FONT_HEIGHT-2, 0x00);
        }
      
        // topleft corner dropdown menu button
        draw_borders(window->x+2, window->y+2, _FONT_HEIGHT-2, _FONT_HEIGHT-2, 0);
        draw_rectangle_px(window->x+2, window->y+2, _FONT_HEIGHT-2, _FONT_HEIGHT-2, _WINDOW_BGCOLOR);
        draw_line(window->x+3, window->y+(_FONT_HEIGHT>>1), window->x+_FONT_HEIGHT-2, window->y+(_FONT_HEIGHT>>1), 0x00);
        draw_line(window->x+3, window->y+(_FONT_HEIGHT>>1)+1, window->x+_FONT_HEIGHT-2, window->y+(_FONT_HEIGHT>>1)+1, 0x00);        
      }
    gprint_text(window->x+_FONT_HEIGHT+4, window->y+1, window->title, _TITLE_TEXTCOLOR, _FONT_HEIGHT, window->x+window->width-24, 0);
    if(update) return;
  }
//  else
//    scrrow+=_FONT_HEIGHT+2;

  draw_rectangle(window->x, scrrow, window->width, window->height, _WINDOW_BGCOLOR);

  for(n=window->element_count;n--;)
  {
    window_drawelement(window, n);
  }

  if(update != 3)
    draw_mouse_cursor(1);

}

void minimize_window(struct prog_window *window)
{
  unsigned int n=0;
  window->minimized=1;
  for(;windows[window_visibility_order[n]]->minimized;n++);
  for(n=window_count;n--;)
    if(!windows[window_visibility_order[n]]->minimized)
    {
      set_active_window(window_visibility_order[n], 0);
      goto drawscreen;
    }
  set_active_window(-1, 0);
  drawscreen:  draw_screen();     
}

void unminimize_window(unsigned int window)
{
  windows[window]->minimized=0;
  set_active_window(window, 0);
  draw_screen();  
//  draw_window(windows[window], 1);
}

void maximize_window(struct prog_window *window)
{
  window->maximized=1;
  
  window->x2 = window->x;
  window->y2 = window->y;
  window->w2 = window->width;
  window->h2 = window->height;

  window->x=0;
  window->y=0;
  window->width=_RES_X;
  window->height=_RES_Y-2-_FONT_HEIGHT;

//  draw_screen();
  draw_window(window, 1, 0);
}

void unmaximize_window(struct prog_window *window)
{
  window->maximized=0;

  window->x = window->x2;
  window->y = window->y2;
  window->width = window->w2;
  window->height = window->h2;

  update_titlebar(window);
}

void del_window(struct prog_window *window)
{
  unsigned int n;
  // remove this window from the window array
  window_count--;
  
  // free all mallocs
//  if(window->hitbox)
    free(window->hitbox);
  free(window->menus.upleft);
  for(n = window->element_count;n--;)
  {
    if(window->window_grid[n]->items)
    {
      while(window->window_grid[n]->c--)
        free(window->window_grid[n]->items[window->window_grid[n]->c]);
      free(window->window_grid[n]->items);
    }
    else if(window->window_grid[n]->fitems)
    {
      while(window->window_grid[n]->c--)
        _ffree(window->window_grid[n]->fitems[window->window_grid[n]->c]);
      _ffree(window->window_grid[n]->fitems);
    }    
    free(window->window_grid[n]->text);
    free(window->window_grid[n]->bitmap);
    free(window->window_grid[n]);
  }
//  if(window->window_grid)
    free(window->window_grid);
//  if(window->icon)
    free(window->icon);
  free(window->function_status);

  free(windows[active_window]);

  windows[active_window] = 0;    

  // clean some memory
  for(n=active_window;n<window_count;n++)
    windows[n] = windows[n+1];
  for(n=0;n<window_count;n++)
  {
    if(window_visibility_order[n] > active_window)
      window_visibility_order[n]--;        
  }
  if(window_count)
  {
    windows = realloc(windows, window_count*sizeof(struct prog_window *));
    window_visibility_order = realloc(window_visibility_order, window_count*sizeof(int));
//    set_active_window(window_count-1);
  }
  if(!window_count)
    set_active_window(-1, 0);
  else
  {
    for(n=window_count;n--;)
      if(!windows[window_visibility_order[n]]->minimized)
      {
        set_active_window(window_visibility_order[n], 0);
        goto endelse;
      }    
    if(n>window_count)
      set_active_window(-1, 0);
  }endelse:
/*  for(n=0;n<window_count;n++)
    if(!windows[n]->minimized)
    {
      set_active_window(n);
      break;
    }    
  if(n==window_count)
    set_active_window(-1);  */
//  else
//    set_active_window(-1);
  // redraw the screen without this window
  draw_screen();  
}

/*
Creates a new window
The last argument is a pointer to a function that is called in a loop if the
window is visible
*/

struct prog_window *new_window(int x, int y, unsigned int width, unsigned int height, unsigned char *title, unsigned resizable, unsigned minimizable, unsigned menubar, unsigned char *icon, int (*function_pointer)(struct prog_window*, int, int*))
{
  struct prog_window *retval = calloc(1, sizeof(struct prog_window));
  unsigned char *tp;
  FILE *fp;
  void *new_pointer;

  if(!retval)
  {
    nomemory:
    nomemory();
    return 0;
  }

  if(x == -1)
  {
    retval->x = window_x;
    window_x += _FONT_HEIGHT+2;
    if(window_x>_RES_X-width)
      window_x = 40;
  }
  else
    retval->x = x;
  if(y == -1)
  {
    retval->y = window_y;
    window_y += _FONT_HEIGHT+2;
    if(window_y>_RES_Y-(height+_FONT_HEIGHT+2))
      window_y = 0;
  }
  else
    retval->y = y;
  retval->width = width;
  retval->height = height;
  retval->window_grid=0;
  retval->element_count=0;
  retval->hitbox_count=0;
  retval->hitbox=0;
  retval->type=1;
  retval->active_element=-1;
  retval->function_pointer = function_pointer;

  // if icon is null pointer, no icon, otherwise load icon
  if(!icon) retval->icon=0;
  else
  {
    if(!(retval->icon = malloc(100 * sizeof(char))))
    {
      free(retval);
      goto nomemory;
    }
    if(!(fp=fopen(icon, "rb")))
    {
      free(retval->icon);
      retval->icon=0;
    }
    fread(retval->icon, sizeof(char), 100, fp);
    fclose(fp);
  }
  
  if(!(tp = retval->title = malloc((1+strlen(title)) * sizeof(char))))
  {
//    if(retval->icon)
    free(retval->icon);
    free(retval);
    goto nomemory;
  }
  while(*tp++ = *title++);

  retval->minimizable = minimizable;
  retval->resizable = resizable;
  retval->maximized = 0;
  retval->minimized = 0;
  retval->menubar = menubar;

  // up-left corner dropdown menu
  retval->menus.upleft_count=2;
  if(resizable) retval->menus.upleft_count+=2;
  if(minimizable) retval->menus.upleft_count++;
  if(!(retval->menus.upleft = malloc(retval->menus.upleft_count* sizeof(char *))))
  {
    free(retval->title);
    //if(retval->icon)
    free(retval->icon);
    free(retval);
    goto nomemory;
  }
  retval->menus.upleft_count=1;  
  retval->menus.upleft[retval->menus.upleft_count++-1] = upleft_move;
  retval->menus.upleft[retval->menus.upleft_count++-1] = upleft_close;
  if(resizable)
  {
    retval->menus.upleft[retval->menus.upleft_count++-1] = upleft_maximize;
    retval->menus.upleft[retval->menus.upleft_count++-1] = upleft_resize;
  }
  if(minimizable)
    retval->menus.upleft[retval->menus.upleft_count-1] = upleft_minimize;
  
  // add this window to the window arrays
  window_count++;
  if(new_pointer = realloc(windows, window_count*sizeof(struct prog_window *)))
    windows = (struct prog_window **)new_pointer;
  else
  {
    free(retval->title);
    //if(retval->icon)
    free(retval->icon);
    free(retval);
    window_count--;
    goto nomemory;
  }
  if(new_pointer = realloc(window_visibility_order, window_count*sizeof(int)))
    window_visibility_order = (int *)new_pointer;
  else
  {
    free(retval->title);
    //if(retval->icon)
    free(retval->icon);
    free(retval);
    window_count--;
    windows = realloc(windows, window_count*sizeof(struct prog_window *));
    goto nomemory;
  }
  windows[window_count-1] = retval;
  window_visibility_order[window_count-1] = window_count-1;

  //active_window = window_count-1;
  set_active_window(window_count-1, 1);

  return retval;
}



void window_recalc_hitboxes(struct prog_window *window)
{
  unsigned int n;
  unsigned int m = 0;
  for(n=0;n<window->element_count;n++)
  {
    if(window->window_grid[n]->type)
    {
      window->hitbox[m].x0 = window->window_grid[n]->x;
      window->hitbox[m].y0 = window->window_grid[n]->y+_FONT_HEIGHT+2;
      if(window->window_grid[n]->type != 4)
      {
        window->hitbox[m].x1 = window->window_grid[n]->x+window->window_grid[n]->width;
        window->hitbox[m].y1 = window->window_grid[n]->y+window->window_grid[n]->height+_FONT_HEIGHT+2;        
      }
      else
      {
        if(!window->window_grid[n]->ctype)
        {
          window->hitbox[m].x1 = window->window_grid[n]->x+12;
          window->hitbox[m].y1 = window->window_grid[n]->y+_FONT_HEIGHT+28+window->window_grid[n]->width;
        }
        else
        {
          window->hitbox[m].x1 = window->window_grid[n]->x+26+window->window_grid[n]->width;
          window->hitbox[m].y1 = window->window_grid[n]->y+_FONT_HEIGHT+14;
        }
      }

      m++;
    }
  }
}

int window_add_hitbox(struct prog_window *window, unsigned int x, unsigned int y, unsigned int width, unsigned int height)
{
  void *new_pointer;
  window->hitbox_count++;
  if(!window->hitbox)
  {
    if(!(window->hitbox = malloc(sizeof(struct hitbox))))
    {
      window->hitbox_count--;            
      return 0;
    }
  }
  else
    if(!(new_pointer = realloc(window->hitbox, window->hitbox_count*sizeof(struct hitbox))))
    {
      window->hitbox_count--;      
      return 0;
    }
    else window->hitbox = (struct hitbox*)new_pointer;

  // create a hitbox for the mouse
  window->hitbox[window->hitbox_count-1].x0 = x;
  window->hitbox[window->hitbox_count-1].y0 = y+_FONT_HEIGHT+2;
  window->hitbox[window->hitbox_count-1].x1 = x+width;
  window->hitbox[window->hitbox_count-1].y1 = y+_FONT_HEIGHT+2+height;

  window->hitbox[window->hitbox_count-1].element = window->element_count-1;

  return 1;
}

int window_grid_addelement(struct prog_window *window, struct window_element *element)
{
  void *new_pointer;
  window->element_count++;

  if(!window->window_grid)
  {
    if(!(window->window_grid = malloc(sizeof(struct window_element*))))
    {
      window->element_count--;
      return 0;
    }
  }
  else
    if(!(new_pointer = realloc(window->window_grid, window->element_count*sizeof(struct window_element*))))
    {
      window->element_count--;      
      return 0;
    }
    else window->window_grid = (struct window_element**)new_pointer;

  window->window_grid[window->element_count-1] = element;    
  return 1;
}

/*
Adds a scrollbar to window

*/

struct window_element *window_scrollbar(struct prog_window *window, unsigned int x, unsigned int y, unsigned type, unsigned int length, unsigned int count, int element, int *value)
{
  struct window_element *retval = calloc(1, sizeof(struct window_element));
//  void *new_pointer;
  if(!retval)
    return 0;

  retval->type=4;
  retval->ctype=type;
  retval->x = x;
  retval->y = y;
  retval->width = length;
  retval->c = count;
  retval->connect_element = element;
  retval->connect_value = value;

  if(!window_grid_addelement(window, retval) || 
    (!type && !window_add_hitbox(window, x, y, 12, 26+length)) ||
    (type && !window_add_hitbox(window, x, y, 26+length, 14)))
  {
    free(retval);
    return 0;
  }
  
  return retval;
}

struct window_element *window_icon(struct prog_window *window, unsigned int x, unsigned int y, unsigned char *text, char *icon_file)
{
  struct window_element *retval = calloc(1, sizeof(struct window_element));
  unsigned char *textp;
  if(!retval)
    return 0;

  retval->type=5;
  retval->width = _WINDOW_ICONS_MARGIN-2;
  retval->height = 39;
  retval->x = x;
  retval->y = y;

  if(!(textp = retval->text = malloc(1+strlen(text)*sizeof(char))))
  {
    free(retval);
    return 0;
  }
  while(*textp++ = *text++);    

  if(!load_icon_bitmap(&retval->bitmap, icon_file))
  {
    free(retval->text);
    free(retval);
    return 0;
  }

  if(!window_grid_addelement(window, retval) ||
     !window_add_hitbox(window, x, y, _WINDOW_ICONS_MARGIN-2, 39))
  {
    free(retval->text);
    free(retval->bitmap);    
    free(retval);
    return 0;
  }


  return retval;  
}

struct window_element *window_list(struct prog_window *window, unsigned int x, unsigned int y, unsigned int width, unsigned int height, unsigned char **items, unsigned int len)
{
  struct window_element *retval = calloc(1, sizeof(struct window_element));
  unsigned char **itemp;
  if(!retval)
    return 0;

  retval->type=3;
  retval->x = x;
  retval->y = y;
  retval->width = width;
  retval->height = height;
  retval->c = len;
  retval->connect_element = -1;
  retval->selectc = -1;
  retval->active = 1;
  if(items)
  {
    if(!(itemp = retval->items = calloc(len,sizeof(char*))))
    {
      free(retval);
      return 0;
    }
    while(len--)
      *itemp++ = *items++;
  }
  else retval->items=0;

  if(!window_grid_addelement(window, retval) ||
     !window_add_hitbox(window, x, y, width, height))
  {
    free(retval->items);
    free(retval);
    return 0;
  }

  return retval;
}

struct window_element *window_textbox(struct prog_window *window, unsigned int x, unsigned int y, unsigned int width, unsigned int height, unsigned char *text, unsigned int len)
{
  struct window_element *retval = calloc(1, sizeof(struct window_element));
  unsigned char *textp;
  if(!retval)
    return 0;

  retval->type=2;
  retval->ctype=0;
  retval->x = x;
  retval->y = y;
  retval->width = width;
  retval->height = height;
  retval->c=len;
  retval->selectc = -1;
  if(len)
  {
    if(!(textp = retval->text = calloc(len,sizeof(char))))
    {
      free(retval);
      return 0;
    }
  }
  if(text)
  {
    if(!retval->text)
      if(!(textp = retval->text = calloc(len,sizeof(char))))
      {
        free(retval);
        return 0;
      }
    while(*textp++ = *text++);
  }

  if(!window_grid_addelement(window, retval) ||
     !window_add_hitbox(window, x, y, width, height))
  {
    free(retval->text);      
    free(retval);
    return 0;
  }

  return retval;
}

struct window_element *window_button(struct prog_window *window, unsigned int x, unsigned int y, unsigned int width, unsigned int height, unsigned char *text, unsigned char color)
{
  struct window_element *retval = calloc(1, sizeof(struct window_element));
  unsigned char *textp;
  if(!retval)
    return 0;

  retval->type=1;
  retval->x = x;
  retval->y = y;
  retval->color = color;
  retval->width = width;
  retval->height = height;
  if(!(textp = retval->text = malloc(1+strlen(text)*sizeof(char))))
  {
    free(retval);
    return 0;
  }

  while(*textp++ = *text++);

  if(!window_grid_addelement(window, retval) ||
     !window_add_hitbox(window, x, y, width, height))
  {
    free(retval->text);      
    free(retval);
    return 0;
  }
  
  return retval;
}

struct window_element *window_text(struct prog_window *window, unsigned int x, unsigned int y, unsigned char *text, unsigned char color)
{
  struct window_element *retval = calloc(1, sizeof(struct window_element));
  unsigned char *textp;
  if(!retval) return 0;

  retval->x = x;
  retval->y = y;
  retval->color = color;
  if(text)
  {
    if(!(textp = retval->text = malloc(1+strlen(text)*sizeof(char))))
    {
      free(retval);
      return 0;
    }

  // copy the string to the struct
    while(*textp++ = *text++);
  }
  
  if(!window_grid_addelement(window, retval))
  {
    free(retval->text);      
    free(retval);
    return 0;
  }


  return retval;
}
/*
This function is used to make a dialog window
The return value if 0 if user presses enter or ok
*/
int dialog(unsigned int x, unsigned int y, unsigned int width, unsigned int height, unsigned type, unsigned help_button, unsigned sound, unsigned char *message, unsigned char *title, unsigned char *helptext)
{
  struct prog_window window;
  int a = 0;
  unsigned int n;
  void *new_pointer;

  window.x = x;
  window.y = y;
  window.width = width;
  window.height = height;
  window.title = title;
  window.element_count = 0;
  window.hitbox_count = 0;
  window.window_grid=0;
  window.hitbox=0;  
  window.minimizable=0;
  window.resizable=0;
  window.maximized=0;
  window.minimized=0;
  window.type=0;

  // up-left corner dropdown menu
  window.menus.upleft_count=2;
  if(window.menus.upleft = malloc(2* sizeof(char *)))
  {
    window.menus.upleft[0] = upleft_move;
    window.menus.upleft[1] = upleft_close;
  }
  else
    return -200;

//  window.hitbox = malloc(sizeof(struct screen_region));

/*  if(mouse)
  {
    titlebar_drag->x0 = x;
    titlebar_drag->y0 = y;
    titlebar_drag->x1 = x+width;
    titlebar_drag->y1 = y+_FONT_HEIGHT+2;
  }*/
  update_titlebar(&window);

  // show message  
  if(!(window_text(&window, 10, 10, message, _WINDOW_BASICTEXTCOLOR)))
  {
    free(window.menus.upleft);
    return -200;
  }
//  gprint_text(window.x+10, window.y+2+_FONT_HEIGHT, message, _WINDOW_BASICTEXTCOLOR, _FONT_HEIGHT, window.x+window.width, 0);
  // create buttons
  n = 0;
  switch(type)
  {
    // type 0: only OK    
    case 0:case 1:
      if(!(window_button(&window, 10, 30, 50, _FONT_HEIGHT+2, dialog_ok, _WINDOW_BASICTEXTCOLOR)))
        goto nomemory2;
    if(!type)break;
    // type 1: ok - cancel    
      if(!(window_button(&window, 10+(++n)*60, 30, 50, _FONT_HEIGHT+2, dialog_cancel, _WINDOW_BASICTEXTCOLOR)))
        goto nomemory2;
    // type 2: yes - no
    break;
    case 2: case 3:
      if(!(window_button(&window, 10, 30, 50, _FONT_HEIGHT+2, dialog_yes, _WINDOW_BASICTEXTCOLOR)))
        goto nomemory2;
      if(!(window_button(&window, 10+(++n)*60, 30, 50, _FONT_HEIGHT+2, dialog_no, _WINDOW_BASICTEXTCOLOR)))
        goto nomemory2;
    if(type==2) break;
    // type 3: yes - no - cancel
      if(!(window_button(&window, 10+(++n)*60, 30, 50, _FONT_HEIGHT+2, dialog_cancel, _WINDOW_BASICTEXTCOLOR)))
        goto nomemory2;
    break;        
  }
  
  if(help_button)
    if(!(window_button(&window, 10+(++n)*60, 30, 60, _FONT_HEIGHT+2, dialog_help, _WINDOW_BASICTEXTCOLOR)))
      goto nomemory2;

  // add this window to the window array
  window_count++;
  if(new_pointer = realloc(windows, window_count*sizeof(struct prog_window *)))
    windows = (struct prog_window**)new_pointer;
  else
  {
    window_count--;
    goto nomemory2;
  }
  if(new_pointer = realloc(window_visibility_order, window_count*sizeof(int)))
    window_visibility_order = (int*)new_pointer;
  else
  {
    window_count--;
    goto nomemory2;
  }
  windows[window_count-1] = &window;
  window_visibility_order[window_count-1] = window_count-1;

  draw_mouse_cursor(2);
  draw_window(&window, 1, 0);
  draw_mouse_cursor(1);

  if(sound)
    make_sound(sound);

  while(1)
  {
    if(mouse)
    {
      a = mouse_handler(&window);
      // -1 = the window has to be re-drawn
      /*if((a = mouse_handler(&window)) == -1)
      {
        draw_screen();
        draw_mouse_cursor(1);
      }*/
    }
    if(kbhit())
    {
      // user presses enter      
      if((a = getch()) == 13)
        a = 100;
      // user presses esc
      else if(a == 27)
        break;
      else if(!a)
      {
        // user presses F1
        if((a = getch()) == 59 && help_button)
          goto helpdialog;
        // alt+m
        else if(a==50)
          a = window_menu(&window, 0);               
      }
    }
    if(help_button && a == 100+window.hitbox_count-1)
    {
      helpdialog:
      dialog(50, 50, 250, 50, 0, 0, 0, helptext, infotitle, 0);
    }
    else
      switch(a)
      {
        case 1: window_kbdmove(&window); draw_mouse_cursor(1); break;
        case 2: case 100: case 101: case 102: goto endwhile;
        case -1: /*draw_window(&window, 1, 0);*/
          draw_screen();
          draw_mouse_cursor(1);
      }
    a=0;    
  }
  endwhile:
  // remove this window from the window array
  window_count--;
  nomemory2:  
  windows[window_count] = 0;
  
  // free all mallocs
  //if(window.hitbox)
  free(window.hitbox);
  free(window.menus.upleft);
  for(n = window.element_count;n--;)
  {
    free(window.window_grid[n]->text);
    free(window.window_grid[n]);
  }
  //if(window.window_grid)
    free(window.window_grid);

  draw_screen();

/*  for(n=0;n<window_count;n++)
    if(!windows[n]->minimized)
    {
      set_active_window(n);
      break;
    }*/
  for(n=window_count;n--;)
    if(!windows[window_visibility_order[n]]->minimized)
    {
      set_active_window(window_visibility_order[n], 1);
      break;
    }    
  if(n==window_count)
    set_active_window(-1, 0);

  draw_mouse_cursor(1);       

  // redraw the screen without this dialog window
//  draw_screen();

  return a-100;
}
